/*
 * bspline
 */

static knotvec(double v[][2], int b, int c, double *x);

#define N(x,y)  n[(a+c+1)*(x)+(y)]

bspline(c, a, v, p) double v[][2];
{
  int b, i, k, l, w;
  double n[100], x[20], atan2();
  double d, e, g, h, t, tstep, tend;

  for (i = 0; i < 100; i++)
	n[i] = 0.0;
  b = --a - c + 2;
  knotvec(v, b, c, x);
  for (l = 0, w = c - 1; w < c + b - 1; w++) {
	for (i = 0; i <= b + (c - 1) * 2 - 1; i++) {
		if (i == w && x[i] != x[i + 1])
				N(i,1) = 1.0;
			else
				N(i,1) = 0.0;
	}
	t = x[w];
	tstep = x[a + c] / (p - 1);
	if (w > c-1)
		t += tstep;
	tend = x[w+1] - 0.5 * tstep;
	for ( ; t < tend; t += tstep) {
		for (k = 2; k <= c; k++) {
			g = h = 0.0;
			for (i = 0; i <= a; i++) {
				if (N(i,k-1) != 0.0)
					d = ((t-x[i]) * N(i,k-1))
					/ (x[i+k-1] - x[i]);
				else
					d = 0.0;
				if (N(i+1,k-1) != 0.0)
					e = ((x[i+k]-t) * N(i+1,k-1))
					/ (x[i+k]-x[i+1]);
				else
					e = 0.0;
				N(i,k) = d + e;
				g += v[i][0] * N(i,k);
				h += v[i][1] * N(i,k);
			}
		}
		if (l++ == 0)
			move(g, h);
		else
			draw(g, h);
	}
  }
  draw(v[a][0], v[a][1]);
}

static knotvec(v, b, c, x) double v[][2], *x;
{
  int i;

  for (i = 0; i <= b + (c - 1) * 2; i++)
	if (i <= c - 1)
		x[i] = 0.0;
	else if ((i < b + c) &&
		(v[i-c][0] != v[i-c+1][0] || v[i-c][1] != v[i-c+1][1]))
		x[i] = x[i - 1] + 1.0;
	else
		x[i] = x[i - 1];
}
