/*
 *  Smith Chart
 *
 *  (C) 1988 K.Hirabayashi
 *
 *  ߥ㡼Ȥޤޤ
 *  ߥ㡼ȤŵΣƻΤҤȤĤǤ
 *  ǡϡ-p, -i ץ󤬻ꤵʤ¤ꡢȿͷȲ򤵤ޤ
 *  ǡϷϡΤȤǤ
 *  u v [ޡ]
 *  ..
*/

#include <stdio.h>
#include <math.h>

void smith(), smithplt();

int pflg;  /* polar (R-Theata) */
int iflg;  /* normalized impedance (Rn + jXn) */

char buf[BUFSIZ], *progname;
int ndata;
char mark[1000];
float ux[1000], uy[1000];

main(argc, argv)
char **argv;
{
  char *s;
  progname = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s != '\0'; s++)
		switch (*s) {
		case 'i': iflg++;
			break;
		case 'p': pflg++;
			break;
		default: fprintf(stderr, "%s: illegal option: %c\n",
			progname, *s);
			break;
		}
  smithplt();
}

void
smith()
{
  static double tic[] = {
	5.0, 2.0, 1.0, .5, .2
  };
  int i;
  char tmps[128];
  double x, y, r, rx, rr, a, b, c;
  double atan(), cos(), sin();

  window(-1.2, 1.2, -1.2, 1.2);
  arc(1.0, 0.0, 6.2832, 0.0, 0.0);
  linetyp(2);
  move(-1.0, 0.0);
  draw(1.0, 0.0);
  for (i = 0; i < 5; i++) {
	r = tic[i];
	x = r / (r + 1.0);
	y = 0.0;
	arc(1.0 / (r + 1.0), 0.0, 6.2832, x, y, x, y);
	move(x - 1.0 / (r + 1.0) + .1, y + .05);
	lorg(5);
	sprintf(tmps, "%g", r);
	label(tmps);
	rx = 1 / r;
	rr = 1.0 / (5.0 - 3.0 * (i > 3) + 1.0);
	a = 2 * atan(1.0 / rx);
	b = 2 * atan(rr / rx);
	c = 4.7124 - a;
	arc(rx, c, 4.7124 - b, 1.0, rx);
	move(rx * cos(c) + 1.0 + .1 * sign(r - 1.0), rx * sin(c) + rx + .1);
	sprintf(tmps, "%g", r);
	label(tmps);
	arc(rx, 1.5708 + b, 1.5708 + a, 1.0, -rx);
	c = 1.5708 + a;
	move(rx * cos(c) + 1.0 - .1 * sign(1.0 - r), rx * sin(1.5708 + a) - rx - .1);
	sprintf(tmps, "%g", -r);
	label(tmps);
  }
  lorg(8);
  move(-1.1, 0.0);
  label("0");
  lorg(2);
  move(1.1, 0.0);
  label("");
}

sign(x)
double x;
{
  return (x > 0) ? 1: -1;
}

void
smithplt()
{
  int i, pen;
  char temps[80];
  double d, u, v, x, y, sin(), cos();
  pen = 0;
  ndata = 0;
  while (fgets(buf, BUFSIZ, stdin) != NULL) {
	x = y = 0;
	mark[ndata] = '\0';
	sscanf(buf, "%le %le %s", &x, &y, &mark[ndata]);
	if (pflg) {
		u = x * cos(y); v = x * sin(y);
	}
	else if (iflg) {
		d = (1.0 + x);
		d = d * d + y * y;
		u = (x * x - 1.0 + y * y) / d;
		v = 2 * y / d;
	}
	else {
		u = x; v = y;
	}
	ux[ndata] = u;
	uy[ndata++] = v;
  }
  gopen(500, 500);
  viewport(.1, .9, .1, .9);
  smith();
  for (i = 0; i < ndata; i++) {
	u = ux[i]; v = uy[i];
	if (pen)
		draw(u, v);
	else
		move(u, v);
	if (mark[i]) {
		sprintf(temps, "%c", mark[i]);
		lorg(5);
		label(temps);
		move(u, v);
	}
	pen = 1;
  }
  gclose();
}
