/*
 *  weibll - 磻֥롦ץåȤԤʤޤ
 *  磻֥ʬۤϡ˲٤Υǡȿμ夤ʬǷޤ
 *  ɤŬ礷ޤ
 *
 *  (C) 1980, 1988 K.Hirabayashi
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define APPEND  1
#define COMP  2
#define VERBOSE  4

char buf[BUFSIZ], *progname;
int ndata, opt;
double data[100], scl, ave, min, alpha, beta, Gamma, mtbf;
double ALPHA, BETA, GAMMA, MTBF;
double v1, v2, v3, v4;  /* view port */
char *pltdev = "console";

main(argc, argv) char **argv;
{
  char c, *s;
  double scaling(), fgamma(), pow();

  progname = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s != '\0'; s++)
		switch (*s) {
		case 'T':
			pltdev = ++s;
			s += strlen(s) - 1;
			break;
		case 'a': opt |= APPEND;
			break;
		case 'c': opt |= COMP;
			break;
		case 'v': opt |= VERBOSE;
			break;
		default: fprintf(stderr, "%s: ellegal option: %c\n",
			progname, *s);
			break;
		}
  v1 = .2; v2 = 0.9; v3 = .15; v4 = .85;
  ndata = 0;
  if ((c = getchar()) == EOF)
	exit(0);
  if (c == 'v')
	scanf("%le %le %le %le", &v1, &v2, &v3, &v4);
  else
	ungetc(c, stdin);
  while (scanf("%le", &data[ndata]) != EOF) {
	if (data[ndata++] <= 0.0) {
		fprintf(stderr,
			"%s:   ޥʥ  ǡ  ޥ\n",
			progname);
		exit(1);
	}
  }
  if (ndata <= 0)
	exit(0);
  sort(data, ndata);
  scl = scaling(data, ndata);
  optmize(data, ndata);
  if (adjust())
	optmize(data, ndata);
  mtbf = pow(alpha, (1.0 / beta)) * fgamma(1.0 + 1.0 / beta) + Gamma;
  ALPHA = alpha; BETA = beta;
  GAMMA = Gamma * scl; MTBF = mtbf * scl;
  if (opt & COMP) {
	prtdata();
	exit(0);
  }
  gopen(600, 400);
  if (!(opt & APPEND))
	gclear();
  plotw(data, ndata);
  gclose();
  exit(0);
}

sort(data, n) double data[];
{
  int gap, i, j;
  double temp;

  for (gap = n / 2; gap > 0; gap /= 2)
	for (i = gap; i < n; i++)
		for (j = i - gap; j >= 0; j -= gap) {
			if (data[j] <= data[j + gap])
				break;
			temp = data[j];
			data[j] = data[j + gap];
			data[j + gap] = temp;
		}
}

double scaling(data, n) double data[];
{
  int i;
  double sf, pow(), log10(), floor();

  for (sf = i = 0; i < n; i++)
	sf += data[i];
  sf = pow(10.0, floor(log10(sf / (double)n)));
  ave = 0.0;
  for (i = 0; i < n; i++) {
	data[i] /= sf;
	if (i == 0 || data[i] < min)
		min = data[i];
	ave += data[i];
  }
  ave /= (double)n;
  return sf;
}

optmize(data, n) double data[];
{
  int i;
  double g, g1, g2, step, tx, ty, txy, qx, qy, qxy, ve, ve0;
  double sx, sy, sxy, cxy;
  double x, y, z, log(), exp();

  for (ve0 = g1 = 0, g2 = min, step = min / 10.0; ; ) {
	for (g = g1; g < g2; g += step) {
		tx = ty = txy = qx = qy = qxy = 0;	/* linear regression */
		for (i = 0; i < n; i++) {
			x = log(data[i] - g);
			y = (double)(i + 1) / (double)(n + 1);
			y = log(log(1.0 / (1.0 - y)));
			z = x + y;
			tx += x; qx += x * x; ty += y; qy += y * y;
			txy += z; qxy += z * z;
		}
		sx = qx - tx * tx / (double)n; sy = qy - ty * ty / (double)n;
		sxy = qxy - txy * txy / (double)n;
		cxy = (sxy - sx - sy) / 2.0;
		ve = (sy - cxy * cxy / sx) / (double)(n - 2);	/* std error */
		if (g > g1 && ve > ve0)
			break;
		ve0 = ve;
		beta = cxy / sx;
		alpha = ty / (double)n - beta * tx / (double)n;
		alpha = exp(-alpha);
		Gamma = g;
	}
	if (step <= min / 100.0)
		break;
	if ((g1 = g - step * 2.0) < 0.0)
		g1 = 0.0;
	g2 = g;
	step = (g2 - g1) / 10.0;
  }
}

adjust()
{
  int i;
  double w, x, log();

  x = 0.0;
  if ((w = log(ave - Gamma)) < 0.0)
	x = 10.0;
  else if (w > 2.3)
	x = 0.1;
  if (x != 0.0) {
	for (i = 0; i < ndata; i++)
		data[i] *= x;
	min *= x;
	scl /= x;
  }
  return (x != 0.0);
}

plotw(data, n) double data[];
{
  int i;
  char temps[128];
  double f, x, y, xp, x1, x2, y1, y2, pow(), log();

  viewport(v1, v2, v3, v4);
  x1 = -2.303; x2 = 4.61; y1 = -7.0; y2 = 2.0;
  window(x1, x2, y1, y2);
  lorg(2);
  move(x1 - 1.0, y2 + .5);
  sprintf(temps, "ξΨ(%%)          MTBF=%.3g", MTBF);
  label(temps);
  move(x1, y1); draw(x2, y1);
  for (i = 0; i < 12; i++) {
	f = (pow(2.0, (double)(i % 3)) + (double)(i % 3 == 2)) *
		pow(10.0, (double)(i / 3 - 3));
	if (i > 8)
		f = 0.9 + 0.09 * (double)(i > 9) + 0.009 * (double)(i > 10);
	y = log(log(1.0 / (1.0 - f)));
	move(x1 - 0.1, y);
	lorg(8);
	sprintf(temps, "%.1f", 100.0 * f);
	label(temps);
	move(x1, y); draw(x2, y);
  }
  move(x1, y2); draw(x2, y2);
  for (i = 0; i < 10; i++) {
	x = (pow(2.0, (double)(i % 3)) + (double)(i % 3 == 2)) *
		pow(10.0, (double)(i / 3 - 1));
	xp = log(x);
	move(xp, y1 - 0.15);
	lorg(6);
	sprintf(temps, "%.3g", x); label(temps);
	move(xp, y1); draw(xp, y2);
  }
  lorg(2);
  move(x1 - 1.0, y1 - 1.0);
  sprintf(temps, "Weibll plot:          (̿ - %.3g) / %.3g", GAMMA, scl);
  label(temps);
  if (opt & VERBOSE) {
	move(x1, y1 - 2.0);
	label("F(x) = 1 - exp(-((x - Gamma) ^ Beta) / Alpha)\n");
	sprintf(temps, "Alpha=%.3g  Beta=%.3g  Gamma=%.3g)",
		ALPHA, BETA, GAMMA);
  }
  lorg(5);
  for (i = 0; i < n; i++) {
	x = log(data[i] - Gamma);
	y = (double)(i + 1) / (double)(n + 1);
	y = log(log(1.0 / (1.0 - y)));
	move(x, y); label("*");
  }
  clip("on");
  linetyp(2);
  if ((xp = 0.1) > 0.0)
	move(x1, beta * log(xp) - log(alpha));
  else
	move((y1 + log(alpha)) / beta, y1);
  if ((xp = 100.0) > 0.0)
	draw(x2, beta * log(xp) - log(alpha));
  else
	draw((y2 + log(alpha)) / beta, y2);
  linetyp(1);
}

prtdata()
{
  printf("F(x) = 1 - exp(-((x - Gamma) ^ Beta) / Alpha)\n");
  printf("MTBF=%.2g  alpha=%.2g  beta=%.2g Gamma=%.2g\n",
	MTBF, ALPHA, BETA, GAMMA);
}

double fgamma(x) double x;
{
  static double a[] = {
	1.0,
	-.577191652,
	.988205891,
	-.897056937,
	.918206857,
	-.756704078,
	.482199394,
	-.193527818,
	.035868343
  };
  int i;
  double x0, x1;

  for (x1 = 1.0; x > 2.0; x1 *= --x)
	;
  for (x--, x0 = a[8], i = 7; i >= 0;i--)
	x0 = x0 * x + a[i];
  return x0 * x1;
}
